#include "bla.h"
#include <stdio.h>
#include <time.h>

#define MAX 447
#define STEP (7.0 / 0x100000)
#define DN 4

int main()
{
	int x, y, n, sx, sy, sn, c;
	double zx, zy, cx, cy, xx, yy, tx, ty;
	bla_Window *w = bla_openWin(1024, 768, "mandel");
	for (y = 0; y < 768; y++) {
		for (x = 0; x < 1024; x++) {
			sn = 0;
			for (sx = 0; sx < DN; sx++) {
				cx = (double) 0x4750 / 0x10000 + (x * DN + sx) * (STEP / DN);
				for (sy = 0; sy < DN; sy++) {
					cy = (double) -0x1e8 / 0x10000 - (y * DN + sy) * (STEP / DN);
					zx = zy = 0;
					for (n = 0; n < MAX; n++) {
						yy = zy * zy;
						xx = zx * zx;
						tx = xx - yy;
						ty = zx * zy;
						ty *= 2.0;
						zy = ty + cy;
						zx = tx + cx;
						xx += yy;
						if (xx > 4.0) break;
					}
					sn += n;
				}
			}
			n = sn / (DN * DN);
			c = 0;
			if (n < 256)
				c = bla_rgb(n, 0, 0);
			else if (n < MAX)
				c = bla_rgb(255, n - 255, 0);
			bla_setPix(w, x, y, c);
		}
		bla_leapFlushAll(w, 300); // ȂƓro߂ʂɔfȂ.
	}
	printf("time=%d\n", clock());
	bla_wait(-1); // EBhE܂ő҂.
}
